/*
** PHREL
** $Id: db.h,v 1.6 2013/04/21 02:29:09 sella Exp $
** Copyright (c) 2004-2013 James M. Sella. All Rights Reserved.
** Released under the GPL Version 2 License.
** http://www.digitalgenesis.com
*/

#ifndef __DGS_DB_H
#define __DGS_DB_H

#ifdef HAVE_CONFIG_H
   #include <config.h>
#endif

#include "phrel.h"

#include <time.h>

#ifdef HAVE_MYSQL
#include <mysql/mysql.h>

int db_library_init(void);
void db_library_end(void);
int db_connect(void);
void db_disconnect(void);
int db_query(MYSQL_RES** res, char* sql);
int db_check(void);
int db_isconnected(void);
int db_sanity(void);
time_t db_last_connect(void);
#endif

#endif

/*
** Local Variables:
** c-basic-offset: 3
** tab-width: 3
** End:
** vim: noet ts=3 sw=3
*/
