/*
** PHREL
** $Id: thread.h,v 1.15 2013/04/21 02:29:09 sella Exp $
** Copyright (c) 2005-2013 James M. Sella. All Rights Reserved.
** Released under the GPL Version 2 License.
** http://www.digitalgenesis.com
*/

#ifndef __DGS_THREAD_H
#define __DGS_THREAD_H

#ifdef HAVE_CONFIG_H
   #include <config.h>
#endif

#include <sys/socket.h>

#include "phrel.h"

struct data_list_t {
	struct sockaddr_storage ss;
	time_t updated;
	unsigned int avg;
	unsigned int sum;
	unsigned int max;
	struct data_list_t *next;
};

/* Function definitions. */
void data_thread(void);
void db_thread(void);
int db_reconnect(void);
int write_data(struct data_list_t *dl_ptr);
int calc_pps(struct data_t* data);
void process_threshold(struct data_t* data, unsigned int pps);
int check_stale(struct data_t *data);
int chain_add(struct data_t* data);
int chain_del(struct data_t* data);
int chain_sync_add(void);
int chain_sync_check(void);
int chain_sync_del(void);
void cleanup(void);

int clean_data();
int read_data();

#endif

/*
** Local Variables:
** c-basic-offset: 3
** tab-width: 3
** End:
** vim: noet ts=3 sw=3
*/
