/*
** PHREL
** $Id: util.h,v 1.13 2013/04/21 02:29:09 sella Exp $
** Copyright (c) 2004-2013 James M. Sella. All Rights Reserved.
** Released under the GPL Version 2 License.
** http://www.digitalgenesis.com
*/

#ifndef __DGS_UTIL_H
#define __DGS_UTIL_H

#ifdef HAVE_CONFIG_H
   #include <config.h>
#endif

#include <arpa/inet.h>
#include <netinet/in.h>
#include <sys/socket.h>

#define inaddrr(x) (*(struct in_addr *) &ifr->x[sizeof sa.sin_port])
#define IFRSIZE ((int)(size * sizeof (struct ifreq)))

#define tvtousec(x) (x.tv_usec + (x.tv_sec * 1000000))

void *get_in_addr(const struct sockaddr_storage *ss);
void *get_in_addr2(const struct sockaddr *sa);
void set_in_addr(struct sockaddr_storage *ss, struct in_addr *in);
void set_in6_addr(struct sockaddr_storage *ss, struct in6_addr *in);
void source_ip(char *interface, struct in_addr *ip);
//int ss_compare(struct sockaddr_storage *ss1, struct sockaddr_storage *ss2);
int ss_cmp(const struct sockaddr_storage *ip1, const struct sockaddr_storage *ip2, const unsigned int cidr);
struct in_addr* cidr_to_mask_in_addr(struct in_addr* in, const unsigned int cidr);
struct in6_addr* cidr_to_mask_in6_addr(struct in6_addr* in6, const unsigned int cidr);
struct sockaddr_storage* ss_apply_mask(struct sockaddr_storage* ip_ss, const struct sockaddr_storage* mask_ss);
struct sockaddr_storage* ss_apply_cidr(struct sockaddr_storage* ip_ss, const unsigned int cidr);
struct in_addr* in_apply_cidr(struct in_addr* in, const unsigned int cidr);
struct in6_addr* in6_apply_cidr(struct in6_addr* in6, const unsigned int cidr);
unsigned long hash_ip(struct sockaddr_storage *key);
unsigned long hash(struct in_addr *key); /* Unused */

#endif

/*
** Local Variables:
** c-basic-offset: 3
** tab-width: 3
** End:
** vim: noet ts=3 sw=3
*/
